from pygame.locals import *

B_SANDBOX = False

#MAX_WIND_PRESSURE = 1
MAX_WIND_PRESSURE = 12
MAX_WIND_CHANGE = 0.0 # Between 0 and 1
#MAX_WIND_CHANGE = 0.5 # Between 0 and 1

# Difficulties

DIFFICULTY_EASY = 0
DIFFICULTY_MEDIUM = 1
DIFFICULTY_HARD = 2


START_WIND_EASY = 3
START_WIND_MEDIUM = 6
START_WIND_HARD = 9

START_WIND = [START_WIND_EASY, START_WIND_MEDIUM, START_WIND_HARD]

START_TIME_EASY = 180
START_TIME_MEDIUM = 120
START_TIME_HARD = 80

START_TIME = [START_TIME_EASY, START_TIME_MEDIUM, START_TIME_HARD]

NUM_BLOCKS_EASY = 80
NUM_BLOCKS_MEDIUM = 60
NUM_BLOCKS_HARD = 40

NUM_BLOCKS = [NUM_BLOCKS_EASY, NUM_BLOCKS_MEDIUM, NUM_BLOCKS_HARD]

WIN_HEIGHT_EASY = 0.85
WIN_HEIGHT_MEDIUM = 0.9
WIN_HEIGHT_HARD = 0.95

WIN_HEIGHT = [WIN_HEIGHT_EASY, WIN_HEIGHT_MEDIUM, WIN_HEIGHT_HARD]

WIN_TIME_EASY = 5
WIN_TIME_MEDIUM = 10
WIN_TIME_HARD = 20

WIN_TIME = [WIN_TIME_EASY, WIN_TIME_MEDIUM, WIN_TIME_HARD]

# ---- Coding enums ----
DIRECTION_LEFT = 0
DIRECTION_RIGHT = 1
DIRECTION_UP = 2
DIRECTION_DOWN = 3


EVENT_PAUSE = USEREVENT + 1
EVENT_OPTIONMENU = USEREVENT + 2
EVENT_DIFFICULTYMENU = USEREVENT + 2


# ----- GFX -----
SCREEN_X = 1024
SCREEN_Y =  768

BORDER_WIDTH_X = 0 # These don't work very well
BORDER_WIDTH_Y = 0 # These don't work very well
MAX_BLOCK_SIZE_X = 150
MAX_BLOCK_SIZE_Y = 150
SCALETOSIZE = (1024, 768)

BLOCK_KILL_TIME = 50.0 # in ticks
BLOCK_KILL_NUM_ROTATION_TICKS = 100

# -- UI -- 
BG_COLOUR = (50, 100, 50)
DISPLAY_BG_COLOUR = (4, 125, 214)
NEXT_BLOCK_BG_COLOUR = (128, 32, 32)
OPTIONS_BG_COLOUR = BG_COLOUR
INFO_BG_COLOUR = BG_COLOUR

SELECTED_BLOCK_COLOUR = (0, 192, 0)
OLD_BLOCK_COLOUR = (0, 0, 192)
TARGET_LINE_COLOUR = (255, 0, 0)

TEXT_HIGHLIGHT_COLOUR = (192, 192, 0)
TEXT_NORMAL_COLOUR = (0, 0, 192) # (192, 0, 192)
TEXT_DANGER_COLOUR = (192, 0, 0)
TEXT_FULL_SCREEN_COLOUR = NEXT_BLOCK_BG_COLOUR

# Positions/Sizes
GAME_SURFACE_POS = (BORDER_WIDTH_X, BORDER_WIDTH_Y)
GAME_SURFACE_SIZE = ((3 * SCALETOSIZE[0] / 4) - BORDER_WIDTH_X, SCALETOSIZE[1] - (2 * BORDER_WIDTH_Y))
NEXT_BLOCK_SURFACE_POS = (SCALETOSIZE[0] - MAX_BLOCK_SIZE_X - BORDER_WIDTH_X, BORDER_WIDTH_Y)
NEXT_BLOCK_SURFACE_SIZE = SCREEN_X - GAME_SURFACE_SIZE[0] - 2 * BORDER_WIDTH_X

TEXT_BORDER_X = 15
TEXT_BORDER_Y = 15

# ---- Game Constants ----
# Properties
BLOCK_DENSITY = 600
PHYSICS_DISTANCE_SCALE_X = 1 # 1 pixel = 0.1mm
PHYSICS_DISTANCE_SCALE_Y = 1 # 1 pixel = 0.1mm

NUM_WIND_POINTS = 5

# Speeds
GFX_TICK_RATE = 25
END_TIME = 7500
